#INCLUDE "box.CH"

#define MY_B_SINGLE ( chr(208)+chr(209)+chr(210)+chr(212)+chr(215)+chr(214)+chr(213)+chr(211) )

function main()
   setmode(25,80)
   set colour to "BG+/N"
   setblink(.T.)
   dispbegin()
   clear screen
   ruler()
   @ 4,10 say "Standard DOS Font Loaded Screen Dimension = "+alltrim(str(maxrow()+1))+" x "+alltrim(str(maxcol()+1))
   @ 6,10 say "Press any key to load a 28 line soft font" colour "W+/N*"
   dispend()
   inkey(0)

   /** load our own soft font **/
   setmode(50,80)          // This SETMODE() is VERY important, clipper is quite dumb and doesn't use its own
                           // maxrow()/maxcol() routines to work out its printable area.
                           // if your not sure what i'm rambling on about here, comment out the setmode() and
                           // recompile/retest you'll soon see!
                           //
                           // just to make things dafter, sometimes you need TWO (2), setmode()'s in a row for
                           // it to sink into clippers brain!!

   loadfont(".\fonts\28.fnt")      // OK, this is the call ... one parameter the name of the FNT file to load
   dispbegin()
   clear screen
   ruler()
   @ 4,10 say "28 line Font Loaded Screen Dimension = "+alltrim(str(maxrow()+1))+" x "+alltrim(str(maxcol()+1))
   @ 6,10 say "Press any key to load standard system 50 line font" colour "W+/N*"
   dispend()
   inkey(0)

   /** standard 50* 80 **/
   setmode(50,80)
   dispbegin()
   clear screen
   ruler()
   @ 4,10 say "50 line stardard font Loaded Screen Dimension = "+alltrim(str(maxrow()+1))+" x "+alltrim(str(maxcol()+1))
   @ 6,10 say "Press any key to load 28 line soft font. for some font fun!" colour "W+/N*"
   dispend()
   inkey(0)

   /** load our own soft font **/
   setmode(50,80)          // This SETMODE() is VERY important, DONT FORGET IT!!!
   loadfont(".\fonts\28.fnt")      // OK, this is the call ... one parameter the name of the FNT file to load
   dispbegin()
   clear screen
   ruler()
   @ 4,10 say "28 line Font Loaded Screen Dimension = "+alltrim(str(maxrow()+1))+" x "+alltrim(str(maxcol()+1))


   setblink(.f.)
   dispbox(6,10,23,75,MY_B_SINGLE+" ", "W+/B*")

   dispbox(10,20,18,35,B_SINGLE+" ", "W+/R*")
   dispbox(10,45,18,60,MY_B_SINGLE+" ", "W+/G")

   @ 12,22 say "A standard"    colour "GR+/R*"
   @ 13,22 say "B_SINGLE box"  colour "GR+/R*"
   @ 15,22 say  "look naff?"   colour "GR+/R*"

   @ 12,47 say "MY_B_SINGLE"   colour "GR+/G"
   @ 13,47 say "box.        "  colour "GR+/G"
   @ 15,47 say  "look good?"   colour "GR+/G"
   
   
   dispend()

   inkey(3)

   @ 22,20 say "Lets add a shadow to both of the boxes above!" colour "W+/B*"

   inkey(3)
   dispbegin()
   dispbox(6,10,23,75,MY_B_SINGLE+" ", "W+/B*")

   shadebox(11,22,19,37)
   dispbox(10,20,18,35,B_SINGLE+" ", "W+/R*")
   shadebox(11,47,19,62)
   dispbox(10,45,18,60,MY_B_SINGLE+" ", "W+/G")

   @ 12,22 say "A standard"    colour "GR+/R*"
   @ 13,22 say "B_SINGLE box"  colour "GR+/R*"
   @ 15,22 say  "look CRAP?"   colour "GR+/R*"

   @ 12,47 say "MY_B_SINGLE"   colour "GR+/G"
   @ 13,47 say "box.        "  colour "GR+/G"
   @ 15,47 say  "look COOL?"   colour "GR+/G"

   dispend()

   inkey(3)

   @ 22,15 say "How about a scroll bar? " colour "W+/B*"

   inkey(3)

   dispbegin()
   dispbox(11,35,17,35, replicate(chr(176),9), "w/n")   // full scroll bar
   @ 10,35 say chr(24) colour "N/GR*"                    // top arrow
   @ 18,35 say chr(25) colour "N/GR*"                    // bottom arrow
   @ 14,35 say chr(32) colour "W/BG*"                  // the block!

   /* scroll bar off our flashy box */
   dispbox(11,60,17,60, replicate(chr(8),9), "N+/GR*")   // full scroll bar
   @ 10,60 say chr(18) colour "N/GR*"                    // top arrow
   @ 18,60 say chr(19) colour "N/GR*"                    // bottom arrow
   @ 14,60 say chr(8)  colour "BG+/GR*"                  // the block!
   dispend()


   @ 22,38 say " Soft Fonts allow you to be Creative!" colour "BG+/B*"

   inkey(10)

   FlashyFinale()


   /* back to normal before we exit */
   setmode(25,80)
   clear screen
return NIL


function ruler()
   set colour to "RG+/N"   
   @ 00,00 say "" 
   @ 01,00 say "       10        20        30        40        50        60        70        80" 
   @ 02,00 say "" 
   @ 03,00 say "" 
   @ 04,00 say "" 
   @ 05,00 say "" 
   @ 06,00 say "" 
   @ 07,00 say "" 
   @ 08,00 say "" 
   @ 09,00 say "10" 
   @ 10,00 say "" 
   @ 11,00 say "" 
   @ 12,00 say "" 
   @ 13,00 say "" 
   @ 14,00 say "" 
   @ 15,00 say "" 
   @ 16,00 say "" 
   @ 17,00 say "" 
   @ 18,00 say "" 
   @ 19,00 say "20" 
   @ 20,00 say "" 
   @ 21,00 say "" 
   @ 22,00 say "" 
   @ 23,00 say "" 
   @ 24,00 say " 25 lines" 
   @ 25,00 say "" 
   @ 26,00 say "" 
   @ 27,00 say " 28 lines" 
   @ 28,00 say "" 
   @ 29,00 say "30" 
   @ 30,00 say "" 
   @ 31,00 say "" 
   @ 32,00 say "" 
   @ 33,00 say "" 
   @ 34,00 say "" 
   @ 35,00 say "" 
   @ 36,00 say "" 
   @ 37,00 say "" 
   @ 38,00 say "" 
   @ 39,00 say "40" 
   @ 40,00 say "" 
   @ 41,00 say "" 
   @ 42,00 say "" 
   @ 43,00 say "" 
   @ 44,00 say "" 
   @ 45,00 say "" 
   @ 46,00 say "" 
   @ 47,00 say "" 
   @ 48,00 say "" 
   @ 49,00 say "50 lines" 
   set colour to "BG+/N"
return NIl



function FlashyFinale()
   local wX  := 12
   local wY  := 12
   local wDX := 1
   local wDY := 1
   local wBuf := ""
   local orgwX := 0
   local orgwY := 0
   local houses := ""
   local car := space(10)+""+space(8)+""+space(20)+""+space(15)+""+space(4)+""+space(4)+""
   local text := " As you can see, you can achieve a lot with SOFT FONTS ... " + ;
                 "but hey, i've thrown in a free shadow routine as "+ ;
                 "well!   Look at that shadow!    It low-lights the high intensity background ... "+ ;
                 "Not many shadow routines do that ... it's a proper shadow!     "+ ;
                 "So do you like the boxes, and the scroll bars ...... Hey, and what "+ ;
                 "about the traffic <grin>    You are Impressed, I can Tell! .............."+ ;
                 "The real impressive feature, is these lines are displayed in an area "+ ;
                 "not nornally visible, lines 26, 27 & 28 !!          "
   local aClr := {"N/R*", "W/R*", "B/R*", "GR+/R*", "G+/R*", "BG+/R*", "W+/R*","RB+/R*"}
   local nClr := 1
   
      
   DO WHILE Nextkey() != 0 ; inkey() ; ENDDO       // Just flush the keyboard buffer!
   wBuf := savescreen(wX,wY,wX+5,wY+30)
   orgwX := wX ; orgwY := wY

   @ 8, 25 say "Icons :                 " colour "W+/B*"
   @ maxrow()-2, 20 say houses colour "w+/N"

   DO WHILE inkey() == 0
      dispbegin()
      restscreen(orgwX,orgwY,orgwX+5,orgwY+30, wBuf)
      orgwX := wX ; orgwY := wY

      @ maxrow()-1, 20 say left(car,50) colour "RB+/N"
      car := right(car,1)+substr(car,1,len(car)-1)
      @ maxrow(), 20 say left(text,50) colour "BG+/B*"
      text := substr(text,2)+left(text,1)    // scroll the text!


      wBuf := savescreen(wX,wY,wX+5,wY+30)
      shadebox(wX+1,wY+2,wX+5,wY+30)
      dispbox(wX,Wy,wX+4,wY+28,MY_B_SINGLE+" ","W+/R*")
      @ wX+1, wY+5 say "If you're impressed" colour "N/R*"
      @ wX+3, wY+10 say "HIT A KEY" colour aClr[(nClr := if(nClr == len(aClr),1, nClr+1))]

      dispend()
      tone(0,1)      // just for a delay!
      wX += wDX ; wY += wDY
      wDX := if(wX == 0 .OR. wX == maxrow()-5,-wDX,wDX)
      wDY := if(wY == 0 .OR. wY == maxcol()-30,-wDY,wDY)

   ENDDO 
return NIL
